// reference Commandstation ex dccwaveform
#include "BlockTimes.h"
#include "mdcTimer.h"
#include "Arduino.h"

MDC_TIMER_INTERRUPT_CALLBACK interruptHandler=0;

void mdcTimer::begin(MDC_TIMER_INTERRUPT_CALLBACK callback) {

  cli();
  
	interruptHandler=callback;
	digitalWrite(9,0);
	pinMode(9,OUTPUT);
	
	DDRD |= PORTDMAP;
	PORTD ^= PORTDSTART;
	DDRB |= PORTBMAP;
	PORTB ^= PORTBSTART;
  
  ADCSRA = (ADCSRA & 0b11111000) | 0b00000100;   // speed up analogRead sample time 
 
  TCCR1A = 0;
	TCCR1B = 0;
  TCCR1A = _BV(COM1A0) | _BV(COM1A1);  // set up pin 9 as PWM, but DO NOT enable it as an output, we only want that PWM correct timer.
  TCCR1B = _BV(WGM13) | _BV(CS11);		 // timer1 pwm mode 8, prescaler set to 8, so the value in ICR1 becomes the actual time in microseconds of half a blockwave!
  
	ICR1 = ONE_BIT;										// just set a zero/idle bit.. the clients expect a space before a package.
	OCR1A = 0;													// does not really matter.. just an arbitraty value
	
	TIMSK1 = _BV(TOIE1);								// we interrupt on overflow, which is always when the counter of the pwm wave hits 0.
	
	sei();
}

// ISR called by timer interrupt every 58uS
ISR(TIMER1_OVF_vect){ 
	interruptHandler(); 
}
