#ifndef mdcTimer_h
#define mdcTimer_h
#include "Arduino.h"

/*
	Set timer1 up for use as a timer for a 'PWM' signal with a twist. The PWM is not actualy used, but is forced into a different timing of raising or dropping pin 9.
	The outcome is a nice correct frequency modulated block wave that can be used to drive a H-bridge.
	
	For theoretical explanation: see https://www.tec4u.nl/mdc/theory.html
	
*/

// right bit = start count.
// B = D13 .. D8
// C = A5 .. A0
// D = D7 .. D0
#define PORTBMAP		B00011000;
#define PORTBSTART	B00001000;
#define PORTDMAP		B00000000;
#define PORTDSTART	B00000000;

typedef void (*MDC_TIMER_INTERRUPT_CALLBACK)();

class mdcTimer {
  public:
  static void begin(MDC_TIMER_INTERRUPT_CALLBACK interrupt);

  private:
};

#endif
